/****************************************************************
 *  bmp2grey.c
 *                      Wandelprogramm fr Bilder
 *                      =========================
 *
 *  15.05.99    Bodo Wenzel     V1.0, bernahme aus pcx2hrg
 ****************************************************************/

/* ACHTUNG, nur ganz quick-and-dirty! Alle Kommentare falsch!! */

/*
Zweck:
- Einlesen von 16-farbigen PCX-PICs
- die Farben 0, 1 und 2 werden allein beachtet
- Ausschneiden vom oberen linken Teilbild 256*192
- Sichern als doppelter HRG-Maschinencode
*/

#include <stdio.h>

#define  FALSE  (0)
#define  TRUE   (!FALSE)

#define  WIDTH   (256L)
#define  HEIGHT  (192)

#define  BUF_SIZE  (WIDTH/8*HEIGHT)

typedef  unsigned char   uchar;
typedef  unsigned short  uint;

uchar  buffer1[BUF_SIZE],buffer2[BUF_SIZE];

int read_data(char *filename);
int save_hrg(char *fn1,char *fn2);

int main(int argc,char *argv[]) {
/*-----------------------------*/
if (argc!=4) {
  puts("usage: bmp2grey source destination1 destination2");
  return(1);
  }

if (!read_data(argv[1]))
  return(2);
if (!save_hrg(argv[2],argv[3]))
  return(3);
return(0);
}

int read_data(char *filename) {
/*---------------------------*/
FILE   *f;
int    y,x,c;
uchar  p,*p1,*p2;

f=fopen(filename,"rb");
if (f==NULL) {
  printf("can't open source!");
  return(FALSE);
  }
fseek(f,0x76,SEEK_SET);
if (ftell(f)!=0x76) {
  printf("can't seek source!");
  return(FALSE);
  }

/* Nibble F=wei, 7=grau, 0=schwarz */

p1=buffer1+(HEIGHT-1)*WIDTH/8-1;
p2=buffer2+(HEIGHT-1)*WIDTH/8-1;
p=0;
for (y=0; y<HEIGHT; y++) {
  for (x=0; x<WIDTH/2; x++) {
    if (p==0) {
      *++p1=0;
      *++p2=0;
      p=0x80;
      }
/*
    printf("\rb1=%p/%p b2=%p/%p p=%02X",buffer1,p1,buffer2,p2,p);
    getchar();
*/
    if ((c=fgetc(f))==EOF) {
      printf("read error on source (2)!");
      fclose(f);
      return(FALSE);
      }
    switch (c&0xF0) {
    case 0x00:
      *p1|=p;
      *p2|=p;
      break;
    case 0x70:
      if (y%2==1)
        *p1|=p;
      else
        *p2|=p;
      break;
    default:
      break;
      }
    p>>=1;
    switch (c&0x0F) {
    case 0x00:
      *p1|=p;
      *p2|=p;
      break;
    case 0x07:
      if (y%2==0)
        *p1|=p;
      else
        *p2|=p;
      break;
    default:
      break;
      }
    p>>=1;
    }
  p1-=2*WIDTH/8;
  p2-=2*WIDTH/8;
  }

if (ferror(f)) {
  printf("read error on source (4)!");
  fclose(f);
  return(FALSE);
  }
fclose(f);
return(TRUE);
}

int save_hrg(char *fn1,char *fn2) {
/*-------------------------------*/
FILE  *f;
int   i;

f=fopen(fn1,"w");
if (f==NULL) {
  puts("can't open destination 1!");
  return(FALSE);
  }

for (i=0; i<HEIGHT*WIDTH/8; i++) {
  if ((i%8)==0)
    fprintf(f,"\n\tdb\t");
  else
    fputc(',',f);
  fprintf(f,"0%02XH",buffer1[i]);
  }
fputc('\n',f);

if (ferror(f)) {
  printf("write error on destination 1!");
  fclose(f);
  return(FALSE);
  }

fclose(f);

f=fopen(fn2,"w");
if (f==NULL) {
  puts("can't open destination 2!");
  return(FALSE);
  }

for (i=0; i<HEIGHT*WIDTH/8; i++) {
  if ((i%8)==0)
    fprintf(f,"\n\tdb\t");
  else
    fputc(',',f);
  fprintf(f,"0%02XH",buffer2[i]);
  }
fputc('\n',f);

if (ferror(f)) {
  printf("write error on destination 2!");
  fclose(f);
  return(FALSE);
  }

fclose(f);
return(TRUE);
}

/* ende */
