;****************************************************************
;*  greypuzz.asm
;*		Maschinencode und Bild fr PUZZLE-Demo
;*		======================================
;*
;*  26.05.99	Bodo Wenzel	V1.0, Erstellung
;****************************************************************

	title	"GREYPUZZ V1.0"

;= Platzierung bestimmen ========================================

p81	segment	4009H,0BFFFH

;= BASIC-Systemvariablen ========================================

	db	0		;VERSN
	dw	0		;E_PPC
	dw	dsp		;D_FILE
	dw	dsp+1		;DF_CC
	dw	var		;VARS
	dw	0		;DEST
	dw	var+1		;E_LINE
	dw	last-1		;CH_ADD
	dw	0		;X_PTR
	dw	last		;STKBOT
	dw	last		;STKEND
	db	0		;BERG
	dw	membot		;MEM
	db	0		;unbenutzt
	db	2		;DF_SZ
	dw	0		;S_TOP
	db	0FFH,0FFH,0FFH	;LAST_K
	db	55		;MARGIN
	dw	dsp		;NXTLIN
	dw	0		;OLDPPC
	db	0		;FLAGX
	dw	0		;STRLEN
	dw	00C8DH		;T_ADDR
	dw	0		;SEED
	dw	0FFFFH		;FRAMES
	db	0,0		;COORDS
	db	0BCH		;PR_CC
	db	33,24		;S_POSN
	db	01000000B	;CDFLAG
	ds	33		;Ausgabepuffer
membot:	ds	30		;Rechenpuffer
	ds	2		;unbenutzt

;= Erste BASIC-Zeile, HRG-Code ==================================

line1:	db	0,1
	dw	line2-$-2
	db	0EAH		;REM

hrg:
	ld	b,4
	djnz	$
	inc	hl		;etwas Verzgerung

	ld	b,192		;Anzahl Zeilen

	ld	hl,(pointer+0)
	ex	de,hl
	ld	hl,(pointer+2)
	ld	(pointer+0),hl
	ex	de,hl		;Adressen tauschen
	ld	(pointer+2),hl	;aktuelle Adresse holen

	ld	de,32		;Offset von Zeile zu Zeile
hrg_loop:
	ld	a,h
	ld	i,a
	ld	i,a
	ld	a,l
	jp	hrg_dummy+8000H
hrg_dummy:
	ld	r,a		;Videoausgabe starten

	db	0,0,0,0,0,0,0,0
	db	0,0,0,0,0,0,0,0
	db	0,0,0,0,0,0,0,0
	db	0,0,0,0,0,0,0,0	;Dummycode

	jp	hrg_end
hrg_end:
	add	hl,de
	djnz	hrg_loop	;noch nicht alle Zeilen?

	ld	a,01EH
	ld	i,a
	ret			;zurck ins ROM

pointer:
	dw	pic1,pic2	;Zeiger auf die Grafiken

	db	076H		;N/L

;= Zweite BASIC-Zeile, Element verschieben ======================

line2:	db	0,2
	dw	line3-$-2
	db	0EAH		;REM

sh_par:
	db	0,0		;Koordinaten der Lcke (x,y)
;----------------------------------------------------------------
;	Vertikallcke abwarten
vsync:
	push	ix
	pop	af
	jp	pe,vsync	;auf IX=0281 (nach VSync) warten
vsync2:
	push	ix
	pop	af
	ret	pe		;auf IX=028F (nach Bild) warten
	jr	vsync2
;----------------------------------------------------------------
;	Stein nach oben (Lcke nach unten)
sh_up:
	ld	de,28*32+6+pic1+31*32
	ld	hl,(sh_par+0)
	add	hl,hl
	add	hl,hl
	add	hl,de		;Zeiger auf erstes Byte

	ld	b,32		;Anzahl Verschiebungen
su_loop:
	call	vsync		;synchronisieren

	push	bc
	call	incr
	ld	de,pic2-pic1-32*32-3
	add	hl,de
	call	incr
	ld	de,pic1-pic2-33*32-3
	add	hl,de		;eine Zeile herauf
	pop	bc

	djnz	su_loop		;noch nicht alle?
	ret
;----------------------------------------------------------------
incr:
	ex	de,hl
	ld	hl,+32
	add	hl,de		;Zieladresse

	ld	a,32		;Anzahl
i_loop:
	ld	bc,4
	ldir			;eine Zeile kopieren

	ld	bc,+32-4
	add	hl,bc
	ex	de,hl
	add	hl,bc
	ex	de,hl		;nchste Adresse

	dec	a
	jr	nz,i_loop	;noch nicht alles?

	ld	bc,-32
	add	hl,bc
	dec	a
	ld	(hl),a
	inc	hl
	ld	(hl),a
	inc	hl
	ld	(hl),a
	inc	hl
	ld	(hl),a		;eine Quellzeile lschen
	ret
;----------------------------------------------------------------
;	Stein nach unten (Lcke nach oben)
sh_down:
	ld	de,28*32+6+pic1+3
	ld	hl,(sh_par+0)
	add	hl,hl
	add	hl,hl
	add	hl,de		;Zeiger auf erstes Byte

	ld	b,32		;Anzahl Verschiebungen
sd_loop:
	call	vsync		;synchronisieren

	push	bc
	call	decr
	ld	de,pic2-pic1+32*32+3
	add	hl,de
	call	decr
	ld	de,pic1-pic2+33*32+3
	add	hl,de		;eine Zeile herab
	pop	bc

	djnz	sd_loop		;noch nicht alle?
	ret
;----------------------------------------------------------------
decr:
	ex	de,hl
	ld	hl,-32
	add	hl,de		;Zieladresse

	ld	a,32		;Anzahl
d_loop:
	ld	bc,4
	lddr			;eine Zeile kopieren

	ld	bc,-32+4
	add	hl,bc
	ex	de,hl
	add	hl,bc
	ex	de,hl		;nchste Adresse

	dec	a
	jr	nz,d_loop	;noch nicht alles?

	ld	bc,+32
	add	hl,bc
	dec	a
	ld	(hl),a
	dec	hl
	ld	(hl),a
	dec	hl
	ld	(hl),a
	dec	hl
	ld	(hl),a		;eine Quellzeile lschen
	ret
;----------------------------------------------------------------
;	Stein nach links (Lcke nach rechts)
sh_left:
	ld	de,28*32+6+pic1+31*32+7
	ld	hl,(sh_par+0)
	add	hl,hl
	add	hl,hl
	add	hl,de		;Zeiger auf erstes Byte

	ld	b,32		;Anzahl Verschiebungen
sl_loop:
	call	vsync		;synchronisieren

	call	left
	ld	de,pic2-pic1+32*32
	add	hl,de
	call	left
	ld	de,pic1-pic2+32*32
	add	hl,de		;eine Spalte nach links

	djnz	sl_loop		;noch nicht alle?
	ret
;----------------------------------------------------------------
left:
	ld	a,b		;Register retten

	ld	de,-32+7	;Adressenoffset

	ld	b,32		;Anzahl
l_loop:
	scf			;Quellspalte lschen
	rl	(hl)
	dec	hl
	rl	(hl)
	dec	hl
	rl	(hl)
	dec	hl
	rl	(hl)
	dec	hl
	rl	(hl)
	dec	hl
	rl	(hl)
	dec	hl
	rl	(hl)
	dec	hl
	rl	(hl)		;eine Zeile schieben

	add	hl,de
	djnz	l_loop		;noch nicht alles?

	ld	b,a		;Register holen
	ret
;----------------------------------------------------------------
;	Stein nach rechts (Lcke nach links)
sh_right:
	ld	de,28*32+6+pic1-4
	ld	hl,(sh_par+0)
	add	hl,hl
	add	hl,hl
	add	hl,de		;Zeiger auf erstes Byte

	ld	b,32		;Anzahl Verschiebungen
sr_loop:
	call	vsync		;synchronisieren

	call	right
	ld	de,pic2-pic1-32*32
	add	hl,de
	call	right
	ld	de,pic1-pic2-32*32
	add	hl,de		;eine Spalte nach rechts

	djnz	sr_loop		;noch nicht alle?
	ret
;----------------------------------------------------------------
right:
	ld	a,b		;Register retten

	ld	de,+32-7	;Adressenoffset

	ld	b,32		;Anzahl
r_loop:
	scf			;Quellspalte lschen
	rr	(hl)
	inc	hl
	rr	(hl)
	inc	hl
	rr	(hl)
	inc	hl
	rr	(hl)
	inc	hl
	rr	(hl)
	inc	hl
	rr	(hl)
	inc	hl
	rr	(hl)
	inc	hl
	rr	(hl)		;eine Zeile schieben

	add	hl,de
	djnz	r_loop		;noch nicht alles?

	ld	b,a		;Register holen
	ret
;----------------------------------------------------------------
	db	076H		;N/L

;= Dritte BASIC-Zeile, Graustufenbild ===========================

line3:	db	0,3
	dw	line4-$-2
	db	0EAH		;REM

	ds	20h - ($ and 1fH)
pic1:
	include	"puzz1.inc"
pic2:
	include	"puzz2.inc"

	db	076H		;N/L

;= Restliche BASIC-Zeilen, zur Adressenausgabe ==================
;	Diese Zeilen knnen gelscht werden.

line4:
	db	0,4
	dw	line5-$-2
	db	0F1H		;LET
	db	038H		;S
	db	014H		;=
	db	01CH		;0
	db	07EH		;Zahl
	db	08FH
	db	(sh_par/128) and 07FH
	db	(sh_par*2) and 0FFH
	db	000H
	db	000H
	db	076H		;N/L

line5:
	db	0,5
	dw	line6-$-2
	db	0F1H		;LET
	db	03AH		;U
	db	014H		;=
	db	01CH		;0
	db	07EH		;Zahl
	db	08FH
	db	(sh_up/128) and 07FH
	db	(sh_up*2) and 0FFH
	db	000H
	db	000H
	db	076H		;N/L

line6:
	db	0,6
	dw	line7-$-2
	db	0F1H		;LET
	db	029H		;D
	db	014H		;=
	db	01CH		;0
	db	07EH		;Zahl
	db	08FH
	db	(sh_down/128) and 07FH
	db	(sh_down*2) and 0FFH
	db	000H
	db	000H
	db	076H		;N/L

line7:
	db	0,7
	dw	line8-$-2
	db	0F1H		;LET
	db	031H		;L
	db	014H		;=
	db	01CH		;0
	db	07EH		;Zahl
	db	08FH
	db	(sh_left/128) and 07FH
	db	(sh_left*2) and 0FFH
	db	000H
	db	000H
	db	076H		;N/L

line8:
	db	0,8
	dw	line9-$-2
	db	0F1H		;LET
	db	037H		;R
	db	014H		;=
	db	01CH		;0
	db	07EH		;Zahl
	db	08FH
	db	(sh_right/128) and 07FH
	db	(sh_right*2) and 0FFH
	db	000H
	db	000H
	db	076H		;N/L

line9:
	db	0,9
	dw	dsp-$-2
	db	0F5H		;PRINT
	db	038H		;S
	db	01AH		;,
	db	01AH		;,
	db	03AH		;U
	db	01AH		;,
	db	029H		;D
	db	01AH		;,
	db	031H		;L
	db	01AH		;,
	db	037H		;R
	db	076H		;N/L

;- Leerer Bildschirm --------------------------------------------

dsp:	db	076H
	db	076H,076H,076H,076H,076H,076H,076H,076H
	db	076H,076H,076H,076H,076H,076H,076H,076H
	db	076H,076H,076H,076H,076H,076H,076H,076H

;- Keine BASIC-Variablen ----------------------------------------

var:	db	080H

;- Ende des abgespeicherten Bereichs ----------------------------

last:
	end
